#include <string.h>
#include "TestLib.h"
#include "pcilib.h"
#include "Card.h"

TCardInfo CardTypeList[] =
{
#include "cardlist.inc"
};
TCardInfo theCard;



int InitCardList( void )
{
    return sizeof( CardTypeList ) / ( sizeof( TCardInfo ) );
}

TTestRun testRun;

TCardInfo InitCard(TCardInfo aCard, Byte bus, Byte df)
{
    char msg[100];
    int i;


    testRun.Tests[testRun.LastTest].Top = wherey();
    testRun.Tests[testRun.LastTest].Bottom = wherey();
    testRun.LastTest = 0;
    testRun.theCard = aCard;
    strcpy(testRun.TesterName, "DefaultTesterName");
    testRun.TimeStart = time(NULL);

    testRun.theCard.bus = bus; testRun.theCard.df = df;

    for ( i=0; i<6; i++ )
      testRun.theCard.BAR[i] = GetIOBaseBAR(bus, df, i);

    testRun.theCard.Base = testRun.theCard.BAR[2];

    testRun.theCard.IRQ = GetIRQ(bus, df);

    EnablePCIeIRQs( testRun.theCard.bus, testRun.theCard.df );
    return aCard;
}

Word GetBaseBAR( Byte bus, Byte df, Byte BAR)
{
    Word  tb;
    read_configuration_word( bus, df, 0x10 + ( BAR * 4 ), &tb );
    return ( tb );
}

Word GetBaseBAR( Byte which )
{
    Word  tb;
    read_configuration_word( theCard.bus, theCard.df, 0x10 + ( which * 4 ), &tb );
    return ( tb );
}

Word GetIOBaseBAR( Byte which )
{
    return ( GetBaseBAR( which ) & 0xFFFC );
}

Word GetIOBaseBAR( Byte bus, Byte df, Byte which )
{
    return ( GetBaseBAR( bus, df, which ) & 0xFFFC );
}

Byte GetIRQ( Byte bus, Byte df )
{
    Word  irqnum;
    read_configuration_word( bus, df, 0x3C, &irqnum );
    return ( irqnum & 0xF );
}

Word GetIRQ( void )
{
    return ( GetIRQ(theCard.bus, theCard.df) );
}

void EnablePCIeIRQs( Byte bus, Byte df)
{
    Word base = GetIOBaseBAR( bus, df, 1 );

    if ( base )
    { OutByte( base + 0x69, 0x09 ); }

}

void EnablePCIeIRQs( void )
{
    Word base = GetIOBaseBAR( 1 );

    if ( base )
    { OutByte( base + 0x69, 0x09 ); }
}
