#ifndef cardheader
#define cardheader
#include "types.h"

typedef enum
{
    t_PCIeIDIO24
} infotype;

typedef struct
{
    Word DeviceID;
    char Name[MAX_TEST_NAME_LENGTH+1];
    Byte bTestFor40752;
    infotype type;
    char n;                                                  // Number of "ports"
    unsigned long AuxData;
    Byte f1;
    Byte f2;
    Byte f3;
    Byte f4;
    Byte _8255Count;
    Byte _8255Offset[6];
    Byte _8254Count;
    Byte _8254Offset[4];
    Byte _16450Count;
    Byte _16450Offset[8];
    Byte DACCount;
    Byte DACOffset;
    Byte EEPROMBase;
    TRegAct ADCStartConversion;
    TRegAct EnableFilters;
    TRegAct DisableFilters;
    TRegAct IRQEnable;
    TRegAct IRQClear;
    TRegAct IRQDisable;
    TRegAct C3Enable;
    TRegAct C3Clear;
    TRegAct C3Disable;
    Word Base;
    Word BAR[6];
    Byte IRQ;
    Byte bus;
    Byte df;
} TCardInfo;

extern TCardInfo CardTypeList[];


#define tcard_ver1 TCardInfo

int InitCardList( void );
TCardInfo InitCard(TCardInfo aCard, Byte busnum, Byte devfunc);
Word GetBaseBAR( Byte bus, Byte df, Byte BAR);
Byte GetIRQ( Byte bus, Byte df );
Word GetIOBaseBAR( Byte bus, Byte df, Byte which );
void EnablePCIeIRQs( Byte bus, Byte df);
#endif
