//IRQs.h
#ifndef IRQsHeader
#define IRQsHeader
#include <stdio.h>
#include "Ticks.h"

extern Word IRQCount, isr_comflag, baddr2, flag, aiflag, irqdata[];

void far interrupt ecom1( ... );
void far interrupt ecom2( ... );
void far interrupt setcomflag( ... );
void interrupt setintflag( void );
void interrupt setaiflag( ... );
void interrupt setai( ... );
void interrupt COSISR( ... );
void interrupt setflag( ... );

void sendEOI( void );

void interrupt isr( ... );

typedef void interrupt far( *TpISR )( ... ); // TpISR is now a type: a pointer to a function that takes "..." as arguments

typedef struct
{
    Taction Action;
    Byte Offset;                  // register byte index
    Word Value;
} TRegAct; // TRegisterAction

typedef struct
{
    Word Base;
    Byte IRQ;                     // IRQ# this was bound to
    int Status;
    bool bDone;                     // indicates IRQ overrun
    TMasterTime tripped;            // time IRQ was attempted to be triggered
    TMasterTime handled;            // time ISR ran
    TRegAct IRQClear;
    Word* pIRQFlag;               // count of IRQs
    TpISR ISR;
} TISR_Handler;

TISR_Handler InitISR( Word Base, int IRQNumber, Taction clearAction, int clearBase, Word &clearValue, Word* pIRQFlag, TpISR anISR = NULL );

TISR_Handler InitISR( TRegAct &clearAction, Word* pIRQFlag, TpISR anISR = NULL);

TISR_Handler InitISR( Word Base, int IRQNumber, TpISR anISR );
TISR_Handler InitISR( Word Base, int IRQNumber, TRegAct act);
TISR_Handler InitISR( int IRQNumber, TpISR anISR );
TISR_Handler InitISR( TpISR anISR );
TISR_Handler InitISR( TRegAct act );

void deInitISR( TISR_Handler ISR );
void deInitISR( Byte IRQ );
void deInitISR( void );

TRegAct ParseRegisterActionToken(char *token);

extern TISR_Handler hISR;




#endif