#ifndef testlib
#define testlib

#include <fstream.h>
#include <time.h>
#include <dos.h>
#include <conio.h>
#include "Types.h"

typedef enum Taction { READBYTE='r', READWORD='R', WRITEBYTE='w', WRITEWORD='W', DRAINFIFO='F', NotApplicable=0, asP104_DIO_48S, ERROR_PARSING };

#include "IRQs.h"
#include "Ticks.h"
#include "card.h"
#include "tests.h"


#define DEFAULT_TEST_RESULT -9999

typedef int TResult;

typedef struct
{
    TResult Result;
    char subTestName[MAX_TEST_NAME_LENGTH];
    Byte Top;
    Byte Bottom;
    Byte ReservedScreenRows;
} TSubTest;

typedef struct
{
    TResult Result;
    char TestName[MAX_TEST_NAME_LENGTH];
    TSubTest SubTests[MAX_NUMBER_OF_SUBTESTS_PER_TEST];
    Word LastSubTest;
    Byte Top;
    Byte Bottom;
} TTest;


/* an execution of all the tests for a single card: "a Test Run" */
typedef struct
{
    TCardInfo theCard;
    bool bScanForNextCard;
    Word nextCardType;
    TCardInfo nextCard;
    char TesterName[MAX_TESTER_NAME_LENGTH];
    time_t TimeStart;
    time_t TimeEnd;
    bool bVerbose;
    bool bDebug;
    TTest Tests[MAX_NUMBER_OF_TESTS_PER_CARD];
    Word LastTest;
} TTestRun;

extern ofstream VerboseLog;
extern TTestRun testRun;

// extern Word theSubTestResult, theTestResult;
extern Word  IRQConfigAddr, IRQClearAddr;
extern bool bDemoMode;


void InitScreen();
Word NewLine(void);


void CardAnnounce();

void TestAnnounce( char* n, ... );
void Instruct( char* msg, int c = WHITE );
int InstructAndWait( char* msg, int c = YELLOW );
int TestResult( int passed = DEFAULT_TEST_RESULT );
void SeekTestBottom(void);
void SubTestAnnounce( char* n, ... );
void SaveSubTestDataRows( Byte rowsToSave );
int SubTestResult( int passed = DEFAULT_TEST_RESULT );


/* extensions to DOS.h */


/* extensions to pcilib.h */
Word GetBaseBAR( Byte which );
Word GetIOBaseBAR( Byte which );
Word GetIRQ( void );
void EnablePCIeIRQs( void );
void DisablePCIeIRQs( void );

/* generic bit-level routines */
void cputbit( bool bit, Byte targetvalue = 0, bool bCompare = FALSE, int targetHitColor = WHITE, int targetMissedColor = LIGHTRED );
bool cprintb( uint32 d, Byte bits = 32, Byte flag = 0, int c = WHITE, int c2 = LIGHTRED );
bool cprintbits( Byte numberOfBitsToPrint, uint32 actualDigitalBits, uint32 targetDigitalBits, bool bCompare = FALSE, uint32 ignoredDigitalBits = 0, int cSame =WHITE, int cDiff =LIGHTRED );

uint32 bitwalk( Byte state, Byte bits );
uint32 Debug_PrintBinaryCompare( uint32 d, uint32 c, uint32 m, Byte bits );

void errPuts( char* msg);
void txtPuts( Byte color, char *msg, ... );
void txtPuts( char *msg, ... );

void clreos( void );
void ConClrLine( void );

void consumeQueuedKeys(void);

Word doRegisterAction(TRegAct Register);

void OutWord( Word Address, Word Value );
void OutByte( Word Address, Byte Value );
Byte InByte( Word Address );
Word InWord( Word Address );
void OutPortDW( Word Port, unsigned long Value );
uint32 InPortDW( Word Port );

#endif // ifndef testlib
