#include "Testlib.h"

TMasterTime ClockHz;

void GetMasterTick( TMasterTime& Target )
{
    __emit__( 0x0F, 0x31 );
    Target.Lo32 = _EAX;
    Target.Hi32 = _EDX;
}

double MasterTickToFloat( TMasterTime& Target )
{
    double  Result = Target.Hi32;
    Result *= 65536.0L * 65536.0L;
    Result += Target.Lo32;
    return ( Result );
}

TMasterTime operator-( TMasterTime A, TMasterTime& B )
{
    if ( B.Lo32 > A.Lo32 ) { --A.Hi32; }

    A.Lo32 -= B.Lo32;
    A.Hi32 -= B.Hi32;
    return ( A );
}

void operator-=( TMasterTime& A, TMasterTime& B )
{
    if ( B.Lo32 > A.Lo32 ) { --A.Hi32; }

    A.Lo32 -= B.Lo32;
    A.Hi32 -= B.Hi32;
}

double operator*( TMasterTime& A, double B )
{
    return ( MasterTickToFloat( A ) * B );
}

void InitClockHz( void )
{
    TMasterTime Tick;
    txtPuts( "\n\rInitializing Timing System, 1 sec..." );
    GetMasterTick( Tick );
    delay( 1000 );
    GetMasterTick( ClockHz );
    ClockHz -= Tick;
    clreos();
}   // InitClockHz
