// Types.h
#ifndef TypesHeader
#define TypesHeader



#define DELAY_Pacing (-1)
#define DELAY_Machine (-2)

void Delay( int ms = DELAY_Pacing );

#define BLINK_DELAY 100
#define MARGIN_TestNameRight 55
#define MARGIN_TestStatusRight 18
#define MARGIN_SubTestNameRight 55
#define MARGIN_SubTestStatusRight -18
#define MARGIN_CardNameRight -20

#define MAX_TEST_NAME_LENGTH 70
#define MAX_TESTER_NAME_LENGTH 70
#define MAX_NUMBER_OF_TESTS_PER_CARD 20
#define MAX_NUMBER_OF_SUBTESTS_PER_TEST 10


#define TicksBeforeTimeout (MasterTickToFloat(ClockHz) / 50.0)

#define MSB(x) ((x>>8)&0xFF)
#define LSB(x) (x&0xFF)

#define max( a, b )             ( (a > b) ? a : b )
#define min( a, b )             ( (a < b) ? a : b )


#define TRUE                    1
#define FALSE                   0

#define IGNORE                  ( -1 )
#define PASSED                  ( 0 )
#define FAILED                  !PASSED


typedef unsigned long uint32;
typedef unsigned short Word;
typedef unsigned char Byte;
typedef Byte Byte;
typedef Byte bool;


typedef union /* dwordX */
{
    uint32  value32;
    struct w
    {
        Word  w0;
        Word  w1;
    };
    struct byt
    {
        Byte  b0;
        Byte  b1;
        Byte  b2;
        Byte  b3;
    } byt;
    struct nyb
    {
        Word  n0 : 4;
        Word  n1 : 4;
        Word  n2 : 4;
        Word  n3 : 4;
        Word  n4 : 4;
        Word  n5 : 4;
        Word  n6 : 4;
        Word  n7 : 4;
    } nyb;
    struct bit
    {
        Word  d00 : 1;
        Word  d01 : 1;
        Word  d02 : 1;
        Word  d03 : 1;
        Word  d04 : 1;
        Word  d05 : 1;
        Word  d06 : 1;
        Word  d07 : 1;
        Word  d08 : 1;
        Word  d09 : 1;
        Word  d10 : 1;
        Word  d11 : 1;
        Word  d12 : 1;
        Word  d13 : 1;
        Word  d14 : 1;
        Word  d15 : 1;
        Word  d16 : 1;
        Word  d17 : 1;
        Word  d18 : 1;
        Word  d19 : 1;
        Word  d20 : 1;
        Word  d21 : 1;
        Word  d22 : 1;
        Word  d23 : 1;
        Word  d24 : 1;
        Word  d25 : 1;
        Word  d26 : 1;
        Word  d27 : 1;
        Word  d28 : 1;
        Word  d29 : 1;
        Word  d30 : 1;
        Word  d31 : 1;
    } bit;
} dwordX;

#endif
